/* eslint-disable max-len */
import { expect } from 'jest-without-globals'
import { printSchema } from 'graphql'
import CatalogBuilder from '../../builders/CatalogBuilder'
import { genGraphCrudSchema } from './genGraphCrudSchema'

// yarn test --testPathPattern genGraphCrudSchema

describe('genGraphCrudSchema', () => {
  test('simple', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.addField('name').setType('string').setRequired()
    cards.addField('lastDigits').setType('int').setRequired()
    cards.addField('registered').setType('datetime').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  name: String!
  lastDigits: Int!
  registered: DateTime!
  active: Boolean
}

"""
A date-time string at UTC, such as 2007-12-03T10:15:30Z, compliant with the \`date-time\` format outlined in section 5.6 of the RFC 3339 profile of the ISO 8601 standard for representation of dates and times using the Gregorian calendar.
"""
scalar DateTime

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  name: String
  name_in: [String]
  name_not_in: [String]
  lastDigits: Int
  lastDigits_in: [Int]
  lastDigits_not_in: [Int]
  lastDigits_lte: Int
  lastDigits_gte: Int
  lastDigits_lt: Int
  lastDigits_gt: Int
  registered: DateTime
  registered_lte: DateTime
  registered_gte: DateTime
  registered_lt: DateTime
  registered_gt: DateTime
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(name: String!, lastDigits: Int!, registered: DateTime!, active: Boolean): Card
  updateCard(id: Int!, name: String!, lastDigits: Int!, registered: DateTime!, active: Boolean): Card
  removeCard(id: Int!): Card
}`)
  })

  test('bigInt id', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.getKey().setType('bigint')
    cards.addField('name').setType('string').setRequired()
    cards.addField('lastDigits').setType('int').setRequired()
    cards.addField('registered').setType('datetime').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: BigInt!
  name: String!
  lastDigits: Int!
  registered: DateTime!
  active: Boolean
}

"""
The \`BigInt\` scalar type represents non-fractional signed whole numeric values.
"""
scalar BigInt

"""
A date-time string at UTC, such as 2007-12-03T10:15:30Z, compliant with the \`date-time\` format outlined in section 5.6 of the RFC 3339 profile of the ISO 8601 standard for representation of dates and times using the Gregorian calendar.
"""
scalar DateTime

input CardFilter {
  q: String
  ids: [BigInt]
  id: BigInt
  name: String
  name_in: [String]
  name_not_in: [String]
  lastDigits: Int
  lastDigits_in: [Int]
  lastDigits_not_in: [Int]
  lastDigits_lte: Int
  lastDigits_gte: Int
  lastDigits_lt: Int
  lastDigits_gt: Int
  registered: DateTime
  registered_lte: DateTime
  registered_gte: DateTime
  registered_lt: DateTime
  registered_gt: DateTime
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: BigInt!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(name: String!, lastDigits: Int!, registered: DateTime!, active: Boolean): Card
  updateCard(id: BigInt!, name: String!, lastDigits: Int!, registered: DateTime!, active: Boolean): Card
  removeCard(id: BigInt!): Card
}`)
  })

  test('int field', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.addField('lastDigits').setType('int').setRequired()

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  lastDigits: Int!
}

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  lastDigits: Int
  lastDigits_in: [Int]
  lastDigits_not_in: [Int]
  lastDigits_lte: Int
  lastDigits_gte: Int
  lastDigits_lt: Int
  lastDigits_gt: Int
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(lastDigits: Int!): Card
  updateCard(id: Int!, lastDigits: Int!): Card
  removeCard(id: Int!): Card
}`)
  })

  test('not autogenerated id key', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.getKey().setAutoGenerated(false)
    cards.addField('name').setType('string').setRequired()
    cards.addField('lastDigits').setType('int').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  name: String!
  lastDigits: Int!
  active: Boolean
}

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  name: String
  name_in: [String]
  name_not_in: [String]
  lastDigits: Int
  lastDigits_in: [Int]
  lastDigits_not_in: [Int]
  lastDigits_lte: Int
  lastDigits_gte: Int
  lastDigits_lt: Int
  lastDigits_gt: Int
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(id: Int!, name: String!, lastDigits: Int!, active: Boolean): Card
  updateCard(id: Int!, name: String!, lastDigits: Int!, active: Boolean): Card
  removeCard(id: Int!): Card
}`)
  })

  test('with int link field', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.getKey().setAutoGenerated(false)
    cards.addField('name').setType('string').setRequired()
    cards.addLinkField('boxes', 'boxId').setType('int').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  name: String!
  boxId: Int!
  active: Boolean
}

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  name: String
  name_in: [String]
  name_not_in: [String]
  boxId: Int
  boxId_in: [Int]
  boxId_not_in: [Int]
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(id: Int!, name: String!, boxId: Int!, active: Boolean): Card
  updateCard(id: Int!, name: String!, boxId: Int!, active: Boolean): Card
  removeCard(id: Int!): Card
}`)
  })

  test('with bigint link field', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.getKey().setAutoGenerated(false)
    cards.addField('name').setType('string').setRequired()
    cards.addLinkField('boxes', 'boxId').setType('bigint').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  name: String!
  boxId: BigInt!
  active: Boolean
}

"""
The \`BigInt\` scalar type represents non-fractional signed whole numeric values.
"""
scalar BigInt

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  name: String
  name_in: [String]
  name_not_in: [String]
  boxId: BigInt
  boxId_in: [BigInt]
  boxId_not_in: [BigInt]
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(id: Int!, name: String!, boxId: BigInt!, active: Boolean): Card
  updateCard(id: Int!, name: String!, boxId: BigInt!, active: Boolean): Card
  removeCard(id: Int!): Card
}`)
  })

  test('with string link field', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.getKey().setAutoGenerated(false)
    cards.addField('name').setType('string').setRequired()
    cards.addLinkField('boxes', 'boxId').setType('string').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  name: String!
  boxId: String!
  active: Boolean
}

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  name: String
  name_in: [String]
  name_not_in: [String]
  boxId: String
  boxId_in: [String]
  boxId_not_in: [String]
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(id: Int!, name: String!, boxId: String!, active: Boolean): Card
  updateCard(id: Int!, name: String!, boxId: String!, active: Boolean): Card
  removeCard(id: Int!): Card
}`)
  })

  test('no search in graph', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards.getKey().setAutoGenerated(false)
    cards.addField('name').setType('string').setRequired()
    cards.addLinkField('boxes', 'boxId').setType('string').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  name: String!
  boxId: String!
  active: Boolean
}

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  name: String
  name_in: [String]
  name_not_in: [String]
  boxId: String
  boxId_in: [String]
  boxId_not_in: [String]
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(id: Int!, name: String!, boxId: String!, active: Boolean): Card
  updateCard(id: Int!, name: String!, boxId: String!, active: Boolean): Card
  removeCard(id: Int!): Card
}`)
  })

  test('with not required on input field', () => {
    const cards = new CatalogBuilder('cards', 'ru')
    cards
      .addField('name')
      .setType('string')
      .setRequired()
      .setRequiredOnInput(false)
    cards.addField('lastDigits').setType('int').setRequired()
    cards.addField('active').setType('bool')

    expect(printSchema(genGraphCrudSchema(cards.build()))).toBe(`type Card {
  id: Int!
  name: String
  lastDigits: Int!
  active: Boolean
}

input CardFilter {
  q: String
  ids: [Int]
  id: Int
  name: String
  name_in: [String]
  name_not_in: [String]
  lastDigits: Int
  lastDigits_in: [Int]
  lastDigits_not_in: [Int]
  lastDigits_lte: Int
  lastDigits_gte: Int
  lastDigits_lt: Int
  lastDigits_gt: Int
  active: Boolean
  active_defined: Boolean
}

type ListMetadata {
  count: Int
}

type Query {
  Card(id: Int!): Card
  allCards(page: Int, perPage: Int, sortField: String, sortOrder: String, filter: CardFilter): [Card]
  _allCardsMeta(page: Int, perPage: Int, filter: CardFilter): ListMetadata
}

type Mutation {
  createCard(name: String, lastDigits: Int!, active: Boolean): Card
  updateCard(id: Int!, name: String, lastDigits: Int!, active: Boolean): Card
  removeCard(id: Int!): Card
}`)
  })
})
